
var buttons = require('sdk/ui/button/action'); 
var tabs = require("sdk/tabs"); 
var data = require("sdk/self").data;
var preferences = require("sdk/simple-prefs").prefs;

var text_entry = require("sdk/panel").Panel({
  width: 220,
  height: 120,
  contentURL: data.url("text-entry.html"),
  contentScriptFile: [data.url("jquery.js"),data.url("get-text.js")],
  backgroundAttachment: data.url("opt-16.png"),
  
});

var button = buttons.ActionButton({
    id: "mozilla-link",   
    label: "Share to my Bitrix24",   
    icon: {     
        "16": "./16x16.png",     
        "32": "./32x32.png",     
        "64": "./64x64.png"   },   
    onClick: handleClick 
}); 

function handleClick(state) {   
    text_entry.show({
      position: button //покажем окно прямо под кнопкой
    });
} 

text_entry.on("show", function() {
  //text_entry.port.emit("show", preferences.b24link);
  console.log("show b24link="+preferences.b24link);
  
});

//если прилетит сообщение, что нужно созранить линк в пропертис
text_entry.port.on("link-entered", function (prop_link) {
  console.log("link-entered (save): "+prop_link);
  preferences.b24link = prop_link;
});

//из content-скрипта прлдетело сообщение что ему нужен линк из пропертис
//достаем и отправляем обратно сообщением
text_entry.port.on("link-load", function () {
  var prop_link = preferences.b24link;
  text_entry.port.emit("show", prop_link);
  //var link_load = preferences.b24link;    
  //console.log("link-load: "+link_load);
});

//если прилетит сообщение что нужно постить сообщение
//строим урл и открываем страницу
//&pref - адрес портала до приложения
//&title -  заголовок текущей страницы
text_entry.port.on("link-go", function (text) {
    let task_url=preferences.b24link;
    let url = tabs.activeTab.url;
    try{
        url = decodeURIComponent(url);
    }catch(e){
        console.error(e.text);
    }
    let title = tabs.activeTab.title;
    //console.log("=== url= "+url);
    let uri = task_url+"?ref="+url+"&title="+title;
    console.log("=== uri="+uri);
    text_entry.hide();
    tabs.open(uri); 
    
});
